Index: /pjproject/trunk/pjsip/build/pjsua_lib.dsp
===================================================================
--- /pjproject/trunk/pjsip/build/pjsua_lib.dsp	(revision 502)
+++ /pjproject/trunk/pjsip/build/pjsua_lib.dsp	(revision 503)
@@ -88,9 +88,9 @@
 # Begin Source File
 
-SOURCE="..\src\pjsua-lib\pjsua_call.c"
+SOURCE="..\src\pjsua-lib\pjsua_acc.c"
 # End Source File
 # Begin Source File
 
-SOURCE="..\src\pjsua-lib\pjsua_console_app.c"
+SOURCE="..\src\pjsua-lib\pjsua_call.c"
 # End Source File
 # Begin Source File
@@ -104,17 +104,9 @@
 # Begin Source File
 
-SOURCE="..\src\pjsua-lib\pjsua_imp.h"
+SOURCE="..\src\pjsua-lib\pjsua_media.c"
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjsua-lib\pjsua_pres.c"
-# End Source File
-# Begin Source File
-
-SOURCE="..\src\pjsua-lib\pjsua_reg.c"
-# End Source File
-# Begin Source File
-
-SOURCE="..\src\pjsua-lib\pjsua_settings.c"
 # End Source File
 # End Group
@@ -128,5 +120,5 @@
 # Begin Source File
 
-SOURCE="..\include\pjsua-lib\pjsua_console_app.h"
+SOURCE="..\include\pjsua-lib\pjsua_internal.h"
 # End Source File
 # End Group
Index: /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 502)
+++ /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 503)
@@ -57,214 +57,640 @@
  */
 #ifndef PJSUA_MAX_CALLS
-#   define PJSUA_MAX_CALLS	    256
+#   define PJSUA_MAX_CALLS	    32
 #endif
 
 
 /**
+ * Max ports in the conference bridge.
+ */
+#ifndef PJSUA_MAX_CONF_PORTS
+#   define PJSUA_MAX_CONF_PORTS	    254
+#endif
+
+
+/**
  * Maximum accounts.
  */
 #ifndef PJSUA_MAX_ACC
-#   define PJSUA_MAX_ACC	    32
+#   define PJSUA_MAX_ACC	    8
 #endif
 
 
+/**
+ * Maximum proxies in account.
+ */
+#ifndef PJSUA_ACC_MAX_PROXIES
+#   define PJSUA_ACC_MAX_PROXIES    8
+#endif
+
+/**
+ * Default registration interval.
+ */
+#ifndef PJSUA_REG_INTERVAL
+#   define PJSUA_REG_INTERVAL	    55
+#endif
+
+
+/** Account identification */
 typedef int pjsua_acc_id;
+
+/** Call identification */
+typedef int pjsua_call_id;
+
+/** SIP transport identification */
+typedef int pjsua_transport_id;
+
+/** Buddy identification */
 typedef int pjsua_buddy_id;
+
+/** File player identification */
 typedef int pjsua_player_id;
+
+/** File recorder identification */
 typedef int pjsua_recorder_id;
+
+/** Conference port identification */
 typedef int pjsua_conf_port_id;
 
 
+/** Constant to identify invalid ID for all sorts of IDs. */
+#define PJSUA_INVALID_ID	    (-1)
+
+
+
 /**
  * Account configuration.
  */
-struct pjsua_acc_config
-{
-    /** SIP URL for account ID (mandatory) */
+typedef struct pjsua_acc_config
+{
+    /** 
+     * The full SIP URL for the account. The value can take name address or 
+     * URL format, and will look something like "sip:account@serviceprovider".
+     *
+     * This field is mandatory.
+     */
     pj_str_t	    id;
 
-    /** Registrar URI (mandatory) */
+    /** 
+     * This is the URL to be put in the request URI for the registration,
+     * and will look something like "sip:serviceprovider".
+     *
+     * This field should be specified if registration is desired. If the
+     * value is empty, no account registration will be performed.
+     */
     pj_str_t	    reg_uri;
 
-    /** Optional contact URI */
+    /** 
+     * Optional URI to be put as Contact for this account. It is recommended
+     * that this field is left empty, so that the value will be calculated
+     * automatically based on the transport address.
+     */
     pj_str_t	    contact;
 
-    /** Service proxy (default: none) */
-    pj_str_t	    proxy;
-
-    /** Default timeout (mandatory) */
-    pj_int32_t	    reg_timeout;
-
-    /** Number of credentials. */
+    /**
+     * Number of proxies in the proxy array below.
+     */
+    unsigned	    proxy_cnt;
+
+    /** 
+     * Optional URI of the proxies to be visited for all outgoing requests 
+     * that are using this account (REGISTER, INVITE, etc). Application need 
+     * to specify these proxies if the service provider requires that requests
+     * destined towards its network should go through certain proxies first
+     * (for example, border controllers).
+     *
+     * These proxies will be put in the route set for this account, with 
+     * maintaining the orders (the first proxy in the array will be visited
+     * first).
+     */
+    pj_str_t	    proxy[PJSUA_ACC_MAX_PROXIES];
+
+    /** 
+     * Optional interval for registration, in seconds. If the value is zero, 
+     * default interval will be used (PJSUA_REG_INTERVAL, 55 seconds).
+     */
+    unsigned	    reg_timeout;
+
+    /** 
+     * Number of credentials in the credential array.
+     */
     unsigned	    cred_count;
 
-    /** Array of credentials. */
-    pjsip_cred_info cred_info[4];
-
-};
-
-
-/**
- * @see pjsua_acc_config
- */
-typedef struct pjsua_acc_config pjsua_acc_config;
-
-
-/**
- * PJSUA settings.
- */
-struct pjsua_config
-{
-    /** SIP UDP signaling port. Set to zero to disable UDP signaling,
-     * which in this case application must manually add a transport
-     * to SIP endpoint.
-     * (default: 5060) 
-     */
-    unsigned	udp_port;
-
-    /** Optional hostname or IP address to publish as the host part of
-     *  Contact header. This must be specified if UDP transport is
-     *  disabled.
-     *  (default: NULL)
-     */
-    pj_str_t	sip_host;
-
-    /** Optional port number to publish in the port part of Contact header.
-     *  This must be specified if UDP transport is disabled.
-     *  (default: 0)
-     */
-    unsigned	sip_port;
-
-    /** Start of RTP port. Set to zero to prevent pjsua from creating
-     *  media transports, which in this case application must manually
-     *  create media transport for each calls.
-     *  (default: 4000) 
-     */
-    unsigned	start_rtp_port;
-
-    /**
-     * Enable incoming and outgoing message logging (default: 1).
+    /** 
+     * Array of credentials. If registration is desired, normally there should
+     * be at least one credential specified, to successfully authenticate
+     * against the service provider. More credentials can be specified, for
+     * example when the requests are expected to be challenged by the
+     * proxies in the route set.
+     */
+    pjsip_cred_info cred_info[PJSUA_ACC_MAX_PROXIES];
+
+} pjsua_acc_config;
+
+
+/**
+ * Call this function to initialize account config with default values.
+ *
+ * @param cfg	    The account config to be initialized.
+ */
+PJ_INLINE(void) pjsua_acc_config_default(pjsua_acc_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+
+    cfg->reg_timeout = PJSUA_REG_INTERVAL;
+}
+
+
+
+/**
+ * Account info. Application can query account info by calling 
+ * #pjsua_acc_get_info().
+ */
+typedef struct pjsua_acc_info
+{
+    /** 
+     * The account ID. 
+     */
+    pjsua_acc_id	id;
+
+    /**
+     * Flag to indicate whether this is the default account.
+     */
+    pj_bool_t		is_default;
+
+    /** 
+     * Account URI 
+     */
+    pj_str_t		acc_uri;
+
+    /** 
+     * Flag to tell whether this account has registration setting
+     * (reg_uri is not empty).
+     */
+    pj_bool_t		has_registration;
+
+    /**
+     * An up to date expiration interval for account registration session.
+     */
+    int			expires;
+
+    /**
+     * Last registration status code. If status code is zero, the account
+     * is currently not registered. Any other value indicates the SIP
+     * status code of the registration.
+     */
+    pjsip_status_code	status;
+
+    /**
+     * String describing the registration status.
+     */
+    pj_str_t		status_text;
+
+    /**
+     * Presence online status for this account.
+     */
+    pj_bool_t		online_status;
+
+    /**
+     * Buffer that is used internally to store the status text.
+     */
+    char		buf_[PJ_ERR_MSG_SIZE];
+
+} pjsua_acc_info;
+
+
+
+/**
+ * STUN configuration.
+ */
+typedef struct pjsua_stun_config
+{
+    /**
+     * The first STUN server IP address or hostname.
+     */
+    pj_str_t	stun_srv1;
+
+    /**
+     * Port number of the first STUN server.
+     * If zero, default STUN port will be used.
+     */
+    unsigned	stun_port1;
+    
+    /**
+     * Optional second STUN server IP address or hostname, for which the
+     * result of the mapping request will be compared to. If the value
+     * is empty, only one STUN server will be used.
+     */
+    pj_str_t	stun_srv2;
+
+    /**
+     * Port number of the second STUN server.
+     * If zero, default STUN port will be used.
+     */
+    unsigned	stun_port2;
+
+} pjsua_stun_config;
+
+
+
+/**
+ * Call this function to initialize STUN config with default values.
+ *
+ * @param cfg	    The STUN config to be initialized.
+ */
+PJ_INLINE(void) pjsua_stun_config_default(pjsua_stun_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+}
+
+
+/**
+ * Transport configuration for creating UDP transports for both SIP
+ * and media.
+ */
+typedef struct pjsua_transport_config
+{
+    /**
+     * UDP port number to bind locally. This setting MUST be specified
+     * even when default port is desired. If the value is zero, the
+     * transport will be bound to any available port, and application
+     * can query the port by querying the transport info.
+     */
+    unsigned		port;
+
+    /**
+     * Optional address where the socket should be bound.
+     */
+    pj_in_addr		ip_addr;
+
+    /**
+     * Flag to indicate whether STUN should be used.
+     */
+    pj_bool_t		use_stun;
+
+    /**
+     * STUN configuration, must be specified when STUN is used.
+     */
+    pjsua_stun_config	stun_config;
+
+} pjsua_transport_config;
+
+
+/**
+ * Call this function to initialize UDP config with default values.
+ *
+ * @param cfg	    The UDP config to be initialized.
+ */
+PJ_INLINE(void) pjsua_transport_config_default(pjsua_transport_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+}
+
+
+/**
+ * Normalize STUN config.
+ */
+PJ_INLINE(void) pjsua_normalize_stun_config( pjsua_stun_config *cfg )
+{
+    if (cfg->stun_srv1.slen) {
+
+	if (cfg->stun_port1 == 0)
+	    cfg->stun_port1 = 3478;
+
+	if (cfg->stun_srv2.slen == 0) {
+	    cfg->stun_srv2 = cfg->stun_srv1;
+	    cfg->stun_port2 = cfg->stun_port1;
+	} else {
+	    if (cfg->stun_port2 == 0)
+		cfg->stun_port2 = 3478;
+	}
+
+    } else {
+	cfg->stun_port1 = 0;
+	cfg->stun_srv2.slen = 0;
+	cfg->stun_port2 = 0;
+    }
+}
+
+
+/**
+ * Duplicate transport config.
+ */
+PJ_INLINE(void) pjsua_transport_config_dup(pj_pool_t *pool,
+					   pjsua_transport_config *dst,
+					   const pjsua_transport_config *src)
+{
+    pj_memcpy(dst, src, sizeof(*src));
+
+    if (src->stun_config.stun_srv1.slen) {
+	pj_strdup_with_null(pool, &dst->stun_config.stun_srv1,
+			    &src->stun_config.stun_srv1);
+    }
+
+    if (src->stun_config.stun_srv2.slen) {
+	pj_strdup_with_null(pool, &dst->stun_config.stun_srv2,
+			    &src->stun_config.stun_srv2);
+    }
+
+    pjsua_normalize_stun_config(&dst->stun_config);
+}
+
+
+
+/**
+ * Transport info.
+ */
+typedef struct pjsua_transport_info
+{
+    /**
+     * PJSUA transport identification.
+     */
+    pjsua_transport_id	    id;
+
+    /**
+     * Transport type.
+     */
+    pjsip_transport_type_e  type;
+
+    /**
+     * Transport type name.
+     */
+    pj_str_t		    type_name;
+
+    /**
+     * Transport string info/description.
+     */
+    pj_str_t		    info;
+
+    /**
+     * Transport flag (see ##pjsip_transport_flags_e).
+     */
+    unsigned		    flag;
+
+    /**
+     * Local address length.
+     */
+    unsigned		    addr_len;
+
+    /**
+     * Local/bound address.
+     */
+    pj_sockaddr		    local_addr;
+
+    /**
+     * Published address (or transport address name).
+     */
+    pjsip_host_port	    local_name;
+
+    /**
+     * Current number of objects currently referencing this transport.
+     */
+    unsigned		    usage_count;
+
+
+} pjsua_transport_info;
+
+
+/**
+ * Media configuration.
+ */
+typedef struct pjsua_media_config
+{
+    /**
+     * Clock rate to be applied to the conference bridge.
+     * If value is zero, default clock rate will be used (16KHz).
+     */
+    unsigned		clock_rate;
+
+    /**
+     * Specify maximum number of media ports to be created in the
+     * conference bridge. Since all media terminate in the bridge
+     * (calls, file player, file recorder, etc), the value must be
+     * large enough to support all of them. However, the larger
+     * the value, the more computations are performed.
+     */
+    unsigned		max_media_ports;
+
+    /**
+     * Specify whether the media manager should manage its own
+     * ioqueue for the RTP/RTCP sockets. If yes, ioqueue will be created
+     * and at least one worker thread will be created too. If no,
+     * the RTP/RTCP sockets will share the same ioqueue as SIP sockets,
+     * and no worker thread is needed.
+     *
+     * Normally application would say yes here, unless it wants to
+     * run everything from a single thread.
+     */
+    pj_bool_t		has_ioqueue;
+
+    /**
+     * Specify the number of worker threads to handle incoming RTP
+     * packets. A value of one is recommended for most applications.
+     */
+    unsigned		thread_cnt;
+
+
+} pjsua_media_config;
+
+
+/**
+ * Use this function to initialize media config.
+ *
+ * @param cfg	The media config to be initialized.
+ */
+PJ_INLINE(void) pjsua_media_config_default(pjsua_media_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+
+    cfg->clock_rate = 16000;
+    cfg->max_media_ports = 32;
+    cfg->has_ioqueue = PJ_TRUE;
+    cfg->thread_cnt = 1;
+}
+
+
+
+/**
+ * Logging configuration.
+ */
+typedef struct pjsua_logging_config
+{
+    /**
+     * Log incoming and outgoing SIP message? Yes!
      */
     pj_bool_t	msg_logging;
 
-    /** Maximum calls to support (default: 4) */
-    unsigned	max_calls;
-
-    /** Maximum slots in the conference bridge (default: 0/calculated
-     *  as max_calls*2
-     */
-    unsigned	conf_ports;
-
-    /** Number of worker threads (value >=0, default: 1) */
-    unsigned	thread_cnt;
-
-    /** Separate ioqueue for media? (default: yes) */
-    pj_bool_t	media_has_ioqueue;
-
-    /** Number of worker thread for media (value >=0, default: 1) */
-    unsigned	media_thread_cnt;
-
-    /** First STUN server IP address. When STUN is configured, then the
-     *  two STUN server settings must be fully set.
-     *  (default: none) 
-     */
-    pj_str_t	stun_srv1;
-
-    /** First STUN port number */
-    unsigned	stun_port1;
-
-    /** Second STUN server IP address */
-    pj_str_t	stun_srv2;
-
-    /** Second STUN server port number */
-    unsigned	stun_port2;
-
-    /** Sound player device ID (default: 0) */
-    unsigned	snd_player_id;
-
-    /** Sound capture device ID (default: 0) */
-    unsigned	snd_capture_id;
-
-    /** Internal clock rate (to be applied to sound devices and conference
-     *  bridge, default is 0/follows the codec, or 44100 for MacOS).
-     */
-    unsigned	clock_rate;
-
-    /** Do not use sound device (default: 0). */
-    pj_bool_t	null_audio;
-
-    /** WAV file to load for auto_play (default: NULL) */
-    pj_str_t	wav_file;
-
-    /** Auto play WAV file for calls? (default: no) */
-    pj_bool_t	auto_play;
-
-    /** Auto loopback calls? (default: no) */
-    pj_bool_t	auto_loop;
-
-    /** Automatically put calls to conference? (default: no) */
-    pj_bool_t	auto_conf;
-
-    /** Speex codec complexity? (default: 10) */
-    unsigned	complexity;
-
-    /** Speex codec quality? (default: 10) */
-    unsigned	quality;
-
-    /** Codec ptime? (default: 0 (follows the codec)) */
-    unsigned	ptime;
-
-    /** Number of additional codecs/"--add-codec" with pjsua (default: 0) */
-    unsigned	codec_cnt;
-
-    /** Additional codecs/"--add-codec" options */
-    pj_str_t	codec_arg[32];
-
-    /** SIP status code to be automatically sent to incoming calls
-     *  (default: 100).
-     */
-    unsigned	auto_answer;
-
-    /** Periodic time to refresh call with re-INVITE (default: 0)
-     */
-    unsigned	uas_refresh;
-
-    /** Maximum incoming call duration (default: 3600) */
-    unsigned	uas_duration;
-
-    /** Outbound proxy (default: none) */
-    pj_str_t	outbound_proxy;
-
-    /** Number of SIP accounts */
-    unsigned	acc_cnt;
-
-    /** SIP accounts configuration */
-    pjsua_acc_config	acc_config[32];
-
-    /** Logging verbosity (default: 5).	*/
-    unsigned	log_level;
-
-    /** Logging to be displayed to stdout (default: 4) */
-    unsigned	app_log_level;
-
-    /** Log decoration */
-    unsigned	log_decor;
-
-    /** Optional log filename (default: NULL) */
+    /**
+     * Input verbosity level. Value 5 is reasonable.
+     */
+    unsigned	level;
+
+    /**
+     * Verbosity level for console. Value 4 is reasonable.
+     */
+    unsigned	console_level;
+
+    /**
+     * Log decoration.
+     */
+    unsigned	decor;
+
+    /**
+     * Optional log filename.
+     */
     pj_str_t	log_filename;
 
-    /** Number of buddies in address book (default: 0) */
-    unsigned	buddy_cnt;
-
-    /** Buddies URI */
-    pj_str_t	buddy_uri[256];
-};
-
-
-/**
- * @see pjsua_config
- */
-typedef struct pjsua_config pjsua_config;
-
+    /**
+     * Optional callback function to be called to write log to 
+     * application specific device. This function will be called for
+     * log messages on input verbosity level.
+     */
+    void       (*cb)(int level, const char *data, pj_size_t len);
+
+
+} pjsua_logging_config;
+
+
+/**
+ * Use this function to initialize logging config.
+ *
+ * @param cfg	The logging config to be initialized.
+ */
+PJ_INLINE(void) pjsua_logging_config_default(pjsua_logging_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+
+    cfg->msg_logging = PJ_TRUE;
+    cfg->level = 5;
+    cfg->console_level = 4;
+    cfg->decor = PJ_LOG_HAS_SENDER | PJ_LOG_HAS_TIME | 
+		 PJ_LOG_HAS_MICRO_SEC | PJ_LOG_HAS_NEWLINE;
+}
+
+/**
+ * Use this function to duplicate logging config.
+ *
+ * @param pool	    Pool to use.
+ * @param dst	    Destination config.
+ * @param src	    Source config.
+ */
+PJ_INLINE(void) pjsua_logging_config_dup(pj_pool_t *pool,
+					 pjsua_logging_config *dst,
+					 const pjsua_logging_config *src)
+{
+    pj_memcpy(dst, src, sizeof(*src));
+    pj_strdup_with_null(pool, &dst->log_filename, &src->log_filename);
+}
+
+
+/**
+ * Buddy configuration.
+ */
+typedef struct pjsua_buddy_config
+{
+    /**
+     * Buddy URL or name address.
+     */
+    pj_str_t	uri;
+
+    /**
+     * Specify whether presence subscription should start immediately.
+     */
+    pj_bool_t	subscribe;
+
+} pjsua_buddy_config;
+
+
+/**
+ * Buddy's online status.
+ */
+typedef enum pjsua_buddy_status
+{
+    /**
+     * Online status is unknown (possibly because no presence subscription
+     * has been established).
+     */
+    PJSUA_BUDDY_STATUS_UNKNOWN,
+
+    /**
+     * Buddy is known to be offline.
+     */
+    PJSUA_BUDDY_STATUS_ONLINE,
+
+    /**
+     * Buddy is offline.
+     */
+    PJSUA_BUDDY_STATUS_OFFLINE,
+
+} pjsua_buddy_status;
+
+
+
+/**
+ * Buddy info.
+ */
+typedef struct pjsua_buddy_info
+{
+    /**
+     * The buddy ID.
+     */
+    pjsua_buddy_id	id;
+
+    /**
+     * The full URI of the buddy, as specified in the configuration.
+     */
+    pj_str_t		uri;
+
+    /**
+     * Buddy's Contact, only available when presence subscription has
+     * been established to the buddy.
+     */
+    pj_str_t		contact;
+
+    /**
+     * Buddy's online status.
+     */
+    pjsua_buddy_status	status;
+
+    /**
+     * Text to describe buddy's online status.
+     */
+    pj_str_t		status_text;
+
+    /**
+     * Flag to indicate that we should monitor the presence information for
+     * this buddy (normally yes, unless explicitly disabled).
+     */
+    pj_bool_t		monitor_pres;
+
+    /**
+     * Internal buffer.
+     */
+    char		buf_[256];
+
+} pjsua_buddy_info;
+
+
+/**
+ * Codec config.
+ */
+typedef struct pjsua_codec_info
+{
+    /**
+     * Codec unique identification.
+     */
+    pj_str_t		codec_id;
+
+    /**
+     * Codec priority (integer 0-255).
+     */
+    pj_uint8_t		priority;
+
+    /**
+     * Internal buffer.
+     */
+    char		buf_[32];
+
+} pjsua_codec_info;
 
 
@@ -272,5 +698,5 @@
  * Application callbacks.
  */
-struct pjsua_callback
+typedef struct pjsua_callback
 {
     /**
@@ -279,11 +705,18 @@
      * detail call states.
      */
-    void (*on_call_state)(int call_index, pjsip_event *e);
+    void (*on_call_state)(pjsua_call_id call_id, pjsip_event *e);
 
     /**
      * Notify application on incoming call.
      */
-    void (*on_incoming_call)(pjsua_acc_id acc_id, int call_index,
+    void (*on_incoming_call)(pjsua_acc_id acc_id, pjsua_call_id call_id,
 			     pjsip_rx_data *rdata);
+
+    /**
+     * Notify application when media state in the call has changed.
+     * Normal application would need to implement this callback, e.g.
+     * to connect the call's media to sound device.
+     */
+    void (*on_call_media_state)(pjsua_call_id call_id);
 
     /**
@@ -294,5 +727,5 @@
      * transfer.
      */
-    void (*on_call_transfered)(int call_index,
+    void (*on_call_transfered)(pjsua_call_id call_id,
 			       const pj_str_t *dst,
 			       pjsip_status_code *code);
@@ -313,22 +746,157 @@
     /**
      * Notify application on incoming pager (i.e. MESSAGE request).
-     * Argument call_index will be -1 if MESSAGE request is not related to an 
+     * Argument call_id will be -1 if MESSAGE request is not related to an
      * existing call.
      */
-    void (*on_pager)(int call_index, const pj_str_t *from,
-		     const pj_str_t *to, const pj_str_t *txt);
+    void (*on_pager)(pjsua_call_id call_id, const pj_str_t *from,
+		     const pj_str_t *to, const pj_str_t *contact,
+		     const pj_str_t *mime_type, const pj_str_t *body);
+
+    /**
+     * Notify application about the delivery status of outgoing pager
+     * request.
+     *
+     * @param call_id	    Containts the ID of the call where the IM was
+     *			    sent, or PJSUA_INVALID_ID if the IM was sent
+     *			    outside call context.
+     * @param to	    Destination URI.
+     * @param body	    Message body.
+     * @param user_data	    Arbitrary data that was specified when sending
+     *			    IM message.
+     * @param status	    Delivery status.
+     * @param reason	    Delivery status reason.
+     */
+    void (*on_pager_status)(pjsua_call_id call_id,
+			    const pj_str_t *to,
+			    const pj_str_t *body,
+			    void *user_data,
+			    pjsip_status_code status,
+			    const pj_str_t *reason);
 
     /**
      * Notify application about typing indication.
      */
-    void (*on_typing)(int call_index, const pj_str_t *from,
-		      const pj_str_t *to, pj_bool_t is_typing);
-
-};
-
-/**
- * @see pjsua_callback
- */
-typedef struct pjsua_callback pjsua_callback;
+    void (*on_typing)(pjsua_call_id call_id, const pj_str_t *from,
+		      const pj_str_t *to, const pj_str_t *contact,
+		      pj_bool_t is_typing);
+
+} pjsua_callback;
+
+
+
+
+/**
+ * PJSUA settings.
+ */
+typedef struct pjsua_config
+{
+
+    /** 
+     * Maximum calls to support (default: 4) 
+     */
+    unsigned	    max_calls;
+
+    /** 
+     * Number of worker threads. Normally application will want to have at
+     * least one worker thread, unless when it wants to poll the library
+     * periodically, which in this case the worker thread can be set to
+     * zero.
+     */
+    unsigned	    thread_cnt;
+
+    /**
+     * Number of outbound proxies in the array.
+     */
+    unsigned	    outbound_proxy_cnt;
+
+    /** 
+     * Specify the URL of outbound proxies to visit for all outgoing requests.
+     * The outbound proxies will be used for all accounts, and it will
+     * be used to build the route set for outgoing requests. The final
+     * route set for outgoing requests will consists of the outbound proxies
+     * and the proxy configured in the account.
+     */
+    pj_str_t	    outbound_proxy[4];
+
+    /** 
+     * Number of credentials in the credential array.
+     */
+    unsigned	    cred_count;
+
+    /** 
+     * Array of credentials. These credentials will be used by all accounts,
+     * and can be used to authenticate against outbound proxies.
+     */
+    pjsip_cred_info cred_info[PJSUA_ACC_MAX_PROXIES];
+
+    /**
+     * Application callback.
+     */
+    pjsua_callback  cb;
+
+} pjsua_config;
+
+
+/**
+ * Use this function to initialize pjsua config.
+ *
+ * @param cfg	pjsua config to be initialized.
+ */
+PJ_INLINE(void) pjsua_config_default(pjsua_config *cfg)
+{
+    pj_memset(cfg, 0, sizeof(*cfg));
+
+    cfg->max_calls = 4;
+    cfg->thread_cnt = 1;
+}
+
+
+/**
+ * Duplicate credential.
+ */
+PJ_INLINE(void) pjsip_cred_dup( pj_pool_t *pool,
+				pjsip_cred_info *dst,
+				const pjsip_cred_info *src)
+{
+    pj_strdup_with_null(pool, &dst->realm, &src->realm);
+    pj_strdup_with_null(pool, &dst->scheme, &src->scheme);
+    pj_strdup_with_null(pool, &dst->username, &src->username);
+    pj_strdup_with_null(pool, &dst->data, &src->data);
+
+}
+
+
+/**
+ * Duplicate pjsua_config.
+ */
+PJ_INLINE(void) pjsua_config_dup(pj_pool_t *pool,
+				 pjsua_config *dst,
+				 const pjsua_config *src)
+{
+    unsigned i;
+
+    pj_memcpy(dst, src, sizeof(*src));
+
+    for (i=0; i<src->outbound_proxy_cnt; ++i) {
+	pj_strdup_with_null(pool, &dst->outbound_proxy[i],
+			    &src->outbound_proxy[i]);
+    }
+
+    for (i=0; i<src->cred_count; ++i) {
+	pjsip_cred_dup(pool, &dst->cred_info[i], &src->cred_info[i]);
+    }
+}
+
+
+/**
+ * Call media status.
+ */
+typedef enum pjsua_call_media_status
+{
+    PJSUA_CALL_MEDIA_NONE,
+    PJSUA_CALL_MEDIA_ACTIVE,
+    PJSUA_CALL_MEDIA_LOCAL_HOLD,
+    PJSUA_CALL_MEDIA_REMOTE_HOLD,
+} pjsua_call_media_status;
 
 
@@ -336,112 +904,173 @@
  * Call info.
  */
-struct pjsua_call_info
-{
-    unsigned		index;
-    pj_bool_t		active;
+typedef struct pjsua_call_info
+{
+    /** Call identification. */
+    pjsua_call_id	id;
+
+    /** Initial call role (UAC == caller) */
     pjsip_role_e	role;
+
+    /** Local URI */
     pj_str_t		local_info;
+
+    /** Local Contact */
+    pj_str_t		local_contact;
+
+    /** Remote URI */
     pj_str_t		remote_info;
+
+    /** Remote contact */
+    pj_str_t		remote_contact;
+
+    /** Dialog Call-ID string. */
+    pj_str_t		call_id;
+
+    /** Call state */
     pjsip_inv_state	state;
+
+    /** Text describing the state */
     pj_str_t		state_text;
+
+    /** Last status code heard, which can be used as cause code */
     pjsip_status_code	last_status;
+
+    /** The reason phrase describing the status. */
     pj_str_t		last_status_text;
+
+    /** Call media status. */
+    pjsua_call_media_status media_status;
+
+    /** Media direction */
+    pjmedia_dir		media_dir;
+
+    /** The conference port number for the call */
+    pjsua_conf_port_id	conf_slot;
+
+    /** Up-to-date call connected duration (zero when call is not 
+     *  established)
+     */
     pj_time_val		connect_duration;
+
+    /** Total call duration, including set-up time */
     pj_time_val		total_duration;
-    pj_bool_t		has_media;
-    pjsua_conf_port_id	conf_slot;
-};
-
-typedef struct pjsua_call_info pjsua_call_info;
-
-
-enum pjsua_buddy_status
-{
-    PJSUA_BUDDY_STATUS_UNKNOWN,
-    PJSUA_BUDDY_STATUS_ONLINE,
-    PJSUA_BUDDY_STATUS_OFFLINE,
-};
-
-typedef enum pjsua_buddy_status pjsua_buddy_status;
-
-
-/**
- * Buddy info.
- */
-struct pjsua_buddy_info
-{
-    pjsua_buddy_id	index;
-    pj_bool_t		is_valid;
+
+    /** Internal */
+    struct {
+	char	local_info[128];
+	char	local_contact[128];
+	char	remote_info[128];
+	char	remote_contact[128];
+	char	call_id[128];
+	char	last_status_text[128];
+    } buf_;
+
+} pjsua_call_info;
+
+
+
+
+/**
+ * Conference port info.
+ */
+typedef struct pjsua_conf_port_info
+{
+    /** Conference port number. */
+    pjsua_conf_port_id	slot_id;
+
+    /** Port name. */
     pj_str_t		name;
-    pj_str_t		display_name;
-    pj_str_t		host;
-    unsigned		port;
-    pj_str_t		uri;
-    pjsua_buddy_status	status;
-    pj_str_t		status_text;
-    pj_bool_t		monitor;
-};
-
-typedef struct pjsua_buddy_info pjsua_buddy_info;
-
-
-/**
- * Account info.
- */
-struct pjsua_acc_info
-{
-    pjsua_acc_id	index;
-    pj_str_t		acc_id;
-    pj_bool_t		has_registration;
-    int			expires;
-    pjsip_status_code	status;
-    pj_str_t		status_text;
-    pj_bool_t		online_status;
-    char		buf[PJ_ERR_MSG_SIZE];
-};
-
-typedef struct pjsua_acc_info pjsua_acc_info;
-
-
-/**
- * Conference port info.
- */
-struct pjsua_conf_port_info
-{
-    pjsua_conf_port_id	slot_id;
-    pj_str_t		name;
+
+    /** Clock rate. */
     unsigned		clock_rate;
+
+    /** Number of channels. */
     unsigned		channel_count;
+
+    /** Samples per frame */
     unsigned		samples_per_frame;
+
+    /** Bits per sample */
     unsigned		bits_per_sample;
+
+    /** Number of listeners in the array. */
     unsigned		listener_cnt;
-    pjsua_conf_port_id	listeners[256];
-};
-
-
-typedef struct pjsua_conf_port_info pjsua_conf_port_info;
+
+    /** Array of listeners (in other words, ports where this port is 
+     *  transmitting to.
+     */
+    pjsua_conf_port_id	listeners[PJSUA_MAX_CONF_PORTS];
+
+} pjsua_conf_port_info;
+
+
+/**
+ * This structure holds information about custom media transport to
+ * be registered to pjsua.
+ */
+typedef struct pjsua_media_transport
+{
+    /**
+     * Media socket information containing the address information
+     * of the RTP and RTCP socket.
+     */
+    pjmedia_sock_info	 skinfo;
+
+    /**
+     * The media transport instance.
+     */
+    pjmedia_transport	*transport;
+
+} pjsua_media_transport;
+
+
+/**
+ * This structure describes additional information to be sent with
+ * outgoing SIP message.
+ */
+typedef struct pjsua_msg_data
+{
+    /**
+     * Additional message headers as linked list.
+     */
+    pjsip_hdr	hdr_list;
+
+    /**
+     * MIME type of optional message body. 
+     */
+    pj_str_t	content_type;
+
+    /**
+     * Optional message body.
+     */
+    pj_str_t	msg_body;
+
+} pjsua_msg_data;
+
+
+/**
+ * Initialize message data.
+ *
+ * @param msg_data  Message data to be initialized.
+ */
+PJ_INLINE(void) pjsua_msg_data_init(pjsua_msg_data *msg_data)
+{
+    pj_memset(msg_data, 0, sizeof(*msg_data));
+    pj_list_init(&msg_data->hdr_list);
+}
 
 
 /*****************************************************************************
- * PJSUA API (defined in pjsua_core.c).
- */
-
-/**
- * Initialize pjsua settings with default parameters.
- */
-PJ_DECL(void) pjsua_default_config(pjsua_config *cfg);
-
-
-/**
- * Validate configuration.
- */
-PJ_DECL(pj_status_t) pjsua_test_config(const pjsua_config *cfg,
-				       char *errmsg,
-				       int len);
-
-
-/**
- * Instantiate pjsua application. This initializes pjlib/pjlib-util, and 
- * creates memory pool factory to be used by application.
+ * PJSUA Core API
+ */
+
+
+/**
+ * Instantiate pjsua application. Application must call this function before
+ * calling any other functions, to make sure that the underlying libraries
+ * are properly initialized. Once this function has returned success,
+ * application must call pjsua_destroy() before quitting.
+ *
+ * @return		PJ_SUCCESS on success, or the appropriate error code.
  */
 PJ_DECL(pj_status_t) pjsua_create(void);
